'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.utf8 = exports.HostNameResolver = exports.Channel = exports.alloc = undefined;

var _browserBuf = require('./browser-buf');

var _browserBuf2 = _interopRequireDefault(_browserBuf);

var _browserChannel = require('./browser-channel');

var _browserChannel2 = _interopRequireDefault(_browserChannel);

var _browserHostNameResolver = require('./browser-host-name-resolver');

var _browserHostNameResolver2 = _interopRequireDefault(_browserHostNameResolver);

var _browserUtf = require('./browser-utf8');

var _browserUtf2 = _interopRequireDefault(_browserUtf);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*

This module exports a set of components to be used in browser environment.
They are not compatible with NodeJS environment.
All files import/require APIs from `node/index.js` by default.
Such imports are replaced at build time with `browser/index.js` when building a browser bundle.

NOTE: exports in this module should have exactly the same names/structure as exports in `node/index.js`.

 */

/**
 * Copyright (c) 2002-2019 "Neo4j,"
 * Neo4j Sweden AB [http://neo4j.com]
 *
 * This file is part of Neo4j.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

var alloc = exports.alloc = function alloc(arg) {
  return new _browserBuf2.default(arg);
};
var Channel = exports.Channel = _browserChannel2.default;
var HostNameResolver = exports.HostNameResolver = _browserHostNameResolver2.default;
var utf8 = exports.utf8 = _browserUtf2.default;