'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.utf8 = exports.HostNameResolver = exports.Channel = exports.alloc = undefined;

var _nodeBuf = require('./node-buf');

var _nodeBuf2 = _interopRequireDefault(_nodeBuf);

var _nodeChannel = require('./node-channel');

var _nodeChannel2 = _interopRequireDefault(_nodeChannel);

var _nodeHostNameResolver = require('./node-host-name-resolver');

var _nodeHostNameResolver2 = _interopRequireDefault(_nodeHostNameResolver);

var _nodeUtf = require('./node-utf8');

var _nodeUtf2 = _interopRequireDefault(_nodeUtf);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*

This module exports a set of components to be used in NodeJS environment.
They are not compatible with browser environment.
All files that require environment-dependent APIs should import this file by default.
Imports/requires are replaced at build time with `browser/index.js` when building a browser bundle.

NOTE: exports in this module should have exactly the same names/structure as exports in `browser/index.js`.

 */

/**
 * Copyright (c) 2002-2019 "Neo4j,"
 * Neo4j Sweden AB [http://neo4j.com]
 *
 * This file is part of Neo4j.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

var alloc = exports.alloc = function alloc(arg) {
  return new _nodeBuf2.default(arg);
};
var Channel = exports.Channel = _nodeChannel2.default;
var HostNameResolver = exports.HostNameResolver = _nodeHostNameResolver2.default;
var utf8 = exports.utf8 = _nodeUtf2.default;