'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _baseHostNameResolver = require('../resolver/base-host-name-resolver');

var _baseHostNameResolver2 = _interopRequireDefault(_baseHostNameResolver);

var _urlUtil = require('../url-util');

var _urlUtil2 = _interopRequireDefault(_urlUtil);

var _dns = require('dns');

var _dns2 = _interopRequireDefault(_dns);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var NodeHostNameResolver = function (_BaseHostNameResolver) {
  (0, _inherits3.default)(NodeHostNameResolver, _BaseHostNameResolver);

  function NodeHostNameResolver() {
    (0, _classCallCheck3.default)(this, NodeHostNameResolver);
    return (0, _possibleConstructorReturn3.default)(this, (NodeHostNameResolver.__proto__ || (0, _getPrototypeOf2.default)(NodeHostNameResolver)).apply(this, arguments));
  }

  (0, _createClass3.default)(NodeHostNameResolver, [{
    key: 'resolve',
    value: function resolve(seedRouter) {
      var _this2 = this;

      var parsedAddress = _urlUtil2.default.parseDatabaseUrl(seedRouter);

      return new _promise2.default(function (resolve) {
        _dns2.default.lookup(parsedAddress.host, { all: true }, function (error, addresses) {
          if (error) {
            resolve(_this2._resolveToItself(seedRouter));
          } else {
            var addressesWithPorts = addresses.map(function (address) {
              return addressWithPort(address, parsedAddress.port);
            });
            resolve(addressesWithPorts);
          }
        });
      });
    }
  }]);
  return NodeHostNameResolver;
}(_baseHostNameResolver2.default); /**
                                    * Copyright (c) 2002-2019 "Neo4j,"
                                    * Neo4j Sweden AB [http://neo4j.com]
                                    *
                                    * This file is part of Neo4j.
                                    *
                                    * Licensed under the Apache License, Version 2.0 (the "License");
                                    * you may not use this file except in compliance with the License.
                                    * You may obtain a copy of the License at
                                    *
                                    *     http://www.apache.org/licenses/LICENSE-2.0
                                    *
                                    * Unless required by applicable law or agreed to in writing, software
                                    * distributed under the License is distributed on an "AS IS" BASIS,
                                    * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
                                    * See the License for the specific language governing permissions and
                                    * limitations under the License.
                                    */

exports.default = NodeHostNameResolver;


function addressWithPort(addressObject, port) {
  var address = addressObject.address;
  var addressFamily = addressObject.family;

  if (!port) {
    return address;
  }

  return addressFamily === 6 ? _urlUtil2.default.formatIPv6Address(address, port) : _urlUtil2.default.formatIPv4Address(address, port);
}